<?php

/**
* MyBB Plugin:  Fight Spam.
* -------------------------------------------------------------------------------------------
* http://www.forumsecurity.eu
* -------------------------------------------------------------------------------------------
* Author : Babjusi 
* http://www.forumsecurity.eu
**/
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}
$plugins->add_hook("datahandler_post_validate_post", "fight_spam");


function fight_spam_info()
{
	return array(
		"name"			=> "مبارزه با اسپم",
		"description"	=> "با این پلاگین شما قادر خواهید بود که حداقل تعداد پست های کاربران که برای تنظیم لینک های پست لازم است تنظیم کنید، فارسی سازی توسط MybbIran.com",
		"website"		=> "http://www.forumsecurity.eu/",
		"version"		=> "1.0",
		"author"		=> "babjusi",
		"authorsite"	=> "http://www.forumsecurity.eu",
		"compatibility"  => "14*",
		'guid'        => 'f6d33f0bfb0d2a4a011629865f5b5818'
	);
}
function fight_spam_activate()
{
	global $db;
	
$settings_group = array(
		'name' => 'fightspam',
		'title' => 'مبارزه با اسپم',
		'description' => 'تنظیمات برای این مود!',
		'disporder' => '1',
		'isdefault' => 'no'
	);
	$db->insert_query('settinggroups',$settings_group);
	$gid = $db->insert_id();
	
	$setting = array(
		'name' => 'enable',
		'title' => 'مود اسپم روشن باشد؟',
		'description' => 'اگر روشن باشد، شما قادر خواهید بود که حداقل تعداد پست های کاربران که برای تنظیم لینک های پست لازم است تنظیم کنید.',
		'optionscode' => 'yesno',
		'value' => '0',
		'disporder' => '1',
		'gid' => intval($gid)
	);
	$db->insert_query('settings',$setting);
	
	$link_minimumposts = array(
		"name" => "link_minimumposts",
		"title" => "تعداد ارسال های مورد نیاز برای داشتن امضا",
		"description" => "در زیر تعداد ارسال هایی که برای کاربران شما برای تنظیم لینک های پست لازم است وارد کنید. به صورت پایه 5 ارسال می باشد.",
		"optionscode" => "text",
		"value" => "5",
		"disporder" => "2",
		"gid" => intval($gid),
		);
	$db->insert_query("settings", $link_minimumposts);
	
	$excluded_linkgroups = array(
		"name" => "excluded_linkgroups",
		"title" => "گروه کاربری که شما می خواهید شامل باشد! برای انتخاب بیشتر از یک گروه کاربری، آی دی آن ها را با کاما از هم جدا کنید.",
		"description" => "<strong>آی دی گروه کاربری</strong> که شما می خواهید شامل محدودیت ارسال باشد.",
		"optionscode" => "text",
		"value" => "",
		"disporder" => "3",
		"gid" => intval($gid),
		);
	$db->insert_query("settings", $excluded_linkgroups);
	
	$excluded_linkusers = array(
		"name" => "excluded_linkusers",
		"title" => "کابرانی که شامل خواهند شد. برای انتخاب بیشتر از یک کاربر، آی دی آن ها را با کاما از یکدیگر جدا کنید.",
		"description" => "<strong>آی دی کاربر</strong> که می خواهید شامل محدودیت ارسال باشد وارد کنید.",
		"optionscode" => "text",
		"value" => "",
		"disporder" => "4",
		"gid" => intval($gid),
		);
	$db->insert_query("settings", $excluded_linkusers);
	
	$excluded_linkforums = array(
		"name" => "excluded_linkforums",
		"title" => "فروم هایی که می خواهید شامل محدودیت لینک ارسال باشند",
		"description" => "<strong>آی دی فروم هایی</strong> که می خواهید شامل محدودیت لینک ارسال باشند وارد کنید. برای انتخاب بیشتر ار یک فروم، <strong>آی دی ها</strong> را با کاما از هم جدا کنید.",
		"optionscode" => "text",
		"value" => "",
		"disporder" => "5",
		"gid" => intval($gid),
		);
	$db->insert_query("settings", $excluded_linkforums);

rebuild_settings();
}

function fight_spam_deactivate()
{
	global $db;

$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='fightspam'");
$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='enable'");	
$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='link_minimumposts'");
$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='excluded_linkgroups'");	
$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='excluded_linkusers'");
$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='excluded_linkforums'");


rebuild_settings();
}
	

function fight_spam($post)	
{
global $mybb, $db, $fid;	

$exludedlinkgroups = explode(',', $mybb->settings['excluded_linkgroups']);
$excludedlinkusers = explode(',', $mybb->settings['excluded_linkusers']);
$excludedlinkforums = explode(',', $mybb->settings['excluded_linkforums']);
	
if($mybb->settings['enable'] == 1)
{
if(!in_array($mybb->user['usergroup'] , $exludedlinkgroups))
{
if(!in_array($mybb->user['uid'] , $excludedlinkusers))
{
if(!in_array($fid , $excludedlinkforums))
{

$post->data['message'] = " ".$post->data['message'];
$post->data['message'] = preg_replace("#([\>\s\(\)])(http){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^\"\s<\[]*)?)#i", "fight_spam", $post->data['message']);
$post->data['message'] = preg_replace("#([\>\s\(\)])(www)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^\"\s<\[]*)?)#i", "fight_spam", $post->data['message']);
$post->data['message'] = preg_replace("#\[img\](.*?)\[/img\]#i","fight_spam", $post->data['message']);
$post->data['message'] = preg_replace("#\[url=([a-z]+?://)([^\r\n\"<]+?)\](.+?)\[/url\]#i","fight_spam", $post->data['message']);
$post->data['message'] = str_replace("  ", " ", $post->data['message']);
			

if (strstr($post->data['message'], "fight_spam") && $mybb->user['postnum'] < intval($mybb->settings['link_minimumposts'])) {
	
	error("An error has occurred. You must have ". $mybb->settings['link_minimumposts']. " posts in order to post links.");
}

}
}
}
}
}
?>